--- inst/include/Rcpp/exceptions_impl.h.orig	2023-04-21 01:26:17.000000000 +0800
+++ inst/include/Rcpp/exceptions_impl.h	2023-04-21 01:26:37.000000000 +0800
@@ -21,6 +21,10 @@
 #ifndef Rcpp__exceptions_impl__h
 #define Rcpp__exceptions_impl__h
 
+#ifdef __APPLE__
+#include <AvailabilityMacros.h>
+#endif
+
 // disable demangler on platforms where we have no support
 #ifndef RCPP_DEMANGLER_ENABLED
 # if defined(_WIN32)     || \
@@ -32,7 +36,8 @@
     defined(_AIX)        || \
     defined(__MUSL__)    || \
     defined(__HAIKU__)   || \
-    defined(__ANDROID__)
+    defined(__ANDROID__) || \
+    (defined(__APPLE__) && MAC_OS_X_VERSION_MAX_ALLOWED < 1050)
 #  define RCPP_DEMANGLER_ENABLED 0
 # elif defined(__GNUC__)  || defined(__clang__)
 #  include <execinfo.h>
